/************************************************************************************


                                  smb Utility

  File: string.h
  Description: strings for international version
  History:
  Contributors: Chezzman1, Insectduel, MirracleMXX, Yy

 ************************************************************************************/
#ifndef STRING_J_H
#define STRING_J_H

#define PROGRAMNAME  "SMB Utility"

#define STRING_VERSION_CONTRIBUTION "Multi-6502 CPU emulator by Neil Bradley (neil@synthcom.com)"

#define STRING_NULL    ""
#define STRING_UNKNOWN "Unknown"

#define STRING_LOGVIEW_FILESAVE "Saved as %s."//"%sɕۑ܂B"
#define STRING_LOGVIEW_FILEOPEN "Loaded %s."//"%sJ܂B"
#define STRING_LOGVIEW_LOADCHR  "Imported CHR-ROM from %s.(%.4xH bytes)"//"%s%.4xH޲ĂCHRROMǂݍ݂܂B"

//
//
#define STRING_FILEOPENDIALOG_CHRLOAD "Import CHR-ROM from file"
#define STRING_WINDOW_EMULATOR        "Emulator"
#define STRING_WINDOW_OBJLIST         "Object List"
#define STRING_WINDOW_OBJVIEW         "Object View"

//
#define STRING_OBJVIEW_TITLE          "%s <%dpage>"
#define STRING_OBJVIEW_TITLE2         "%s <%d-%dpage>"
#define STRING_OBJVIEW_TOOLTIP        "%d,(%d,%d) %s"

//
#define STRING_STATUSBAR_EMULOAD  "Loaded state."
#define STRING_STATUSBAR_EMUSAVE  "Saved state."
#define STRING_STATUSBAR_FILESAVE "Saved file."

//
#define STRING_FILEERROR_SAVE       "Failed to save."
#define STRING_FILEERROR_SAVEAS     "Failed to save as."
#define STRING_FILEERROR_FILEFORMAT "Found file format(file type) error."
#define STRING_FILEERROR_NOTFOUND   "Not found file."

//
#define STRING_CONFIRM_SAVE         "Overwrite file?"//"㏑ۑ܂H"
#define STRING_CONFIRM_EXIT         "Save and exit?"
#define STRING_CONFIRM_RELOAD       "File has been changed by another editor.\nReload?"
#define STRING_CONFIRM_DEMORECORD   "Start recording demonstration?"
#define STRING_CONFIRM_DEMORECORD2  "Stoped recording demonstration."
#define STRING_CONFIRM_UPDATEWORLD  "Refresh world data?"

//
#define STRING_OPTIONDIALOG_TITLE       "Option"
#define STRING_OPTIONDIALOG_EMULATOR    "Emulator"
#define STRING_OPTIONDIALOG_EDITOR      "Editor"
#define STRING_OPTIONDIALOG_APPLICATION "Application"
#define STRING_OPTIONDIALOG_OBJECTVIEW  "Object View"

//
#define STRING_TOOLTIP_OPEN              "Open"
#define STRING_TOOLTIP_SAVE              "Save"
#define STRING_TOOLTIP_ROOM              "Choose Room"
#define STRING_TOOLTIP_BADGUYS           "Badguys Mode"
#define STRING_TOOLTIP_MAP               "Map Mode"
#define STRING_TOOLTIP_TESTPLAY          "Start of Room"
#define STRING_TOOLTIP_PAGETESTPLAY      "Current Page"
#define STRING_TOOLTIP_HALFPOINTTESTPLAY "Halfway Point"
#define STRING_TOOLTIP_STOP              "End"
#define STRING_TOOLTIP_TESTPLAYSETTING   "Test Configuration"

//
#define STRING_SENDOBJECT_SRCERROR "Can't send source object."
#define STRING_SENDOBJECT_DSTERROR "There are no objects in destination page."
#define STRING_SENDOBJECT_OVEROBJ  "Can't send any more objects to the destination room."//"ٰтɂ́Aȏ޼ުĂ𑗂邱Ƃł܂B"

#define STRING_UNDO_MENUTEXT              "&Undo \"%s\""
#define STRING_UNDONAME_KEYEDIT           "Keyboard Input"
#define STRING_UNDONAME_DLGEDIT           "Dialog Input"
#define STRING_UNDONAME_SENDOBJ           "Send Object"
#define STRING_UNDONAME_HEADDLG           "Edit Header"
#define STRING_UNDONAME_CHRLOAD           "Import CHR-ROM"
#define STRING_UNDONAME_TOOLSTR           "Edit Text"
#define STRING_UNDONAME_TOOLLOOPBIN       "Edit Looping"
#define STRING_UNDONAME_TOOLWORLD         "World Data Update"//"Auto Refresh World Data"
#define STRING_UNDONAME_TOOLAREAROOM      "Sort Areas"
#define STRING_UNDONAME_TOOLDEMORECORDER  "Record Intro Demo"//"Demo Recording"
#define STRING_UNDONAME_TOOLOTHER         "Edit Some Game Stuff"
//#define STRING_UNDONAME_TOOLGLOBAL        "General Setting"


#define STRING_POLEGFX_DEFAULT "Default"
#define STRING_POLEGFX_ROPE    "Rope"
#define STRING_POLEGFX_TREE    "Tree"
#define STRING_POLEGFX_OTHER   "Other"

#define STRING_SETTING_WORLDX   "World%d"
#define STRING_SETTING_WARPZONE "Warp Zone"
#define STRING_SETTING_1UP      "1UP Mushroom"
#define STRING_SETTING_KOOPA    "Bowser"
#define STRING_SETTING_WORLD    "World"
#define STRING_SETTING_OTHER    "Other"
#define STRING_SETTING_TITLE    "Edit Some Game Stuff"


#define STRING_STRINGDATA_01 "MARIO(Status bar)"
#define STRING_STRINGDATA_02 "MARIO(Time up at two players mode)"
#define STRING_STRINGDATA_03 "MARIO(Game over)"
#define STRING_STRINGDATA_04 "LUIGI(Status bar/Time up/Game over)"
#define STRING_STRINGDATA_05 "WORLD  TIME(Status Bar)"
#define STRING_STRINGDATA_06 "WORLD(On the World 1-1 ect screen)"
#define STRING_STRINGDATA_07 "TIME UP"
#define STRING_STRINGDATA_08 "GAME OVER"
#define STRING_STRINGDATA_09 "WELCOME TO WARP ZONE!"
#define STRING_STRINGDATA_10 "THANK YOU MARIO!"
#define STRING_STRINGDATA_11 "THANK YOU LUIGI!"
#define STRING_STRINGDATA_12 "BUT OUR PRINCESS IS IN"
#define STRING_STRINGDATA_13 "ANOTHER CASTLE!"
#define STRING_STRINGDATA_14 "YOUR QUEST IS OVER."
#define STRING_STRINGDATA_15 "WE PRESENT YOU A NEW QUEST."
#define STRING_STRINGDATA_16 "PUSH BUTTON B"
#define STRING_STRINGDATA_17 "TO SELECT A WORLD"
#define STRING_STRINGDATA_18 "Copyright notice(Title screen)"
#define STRING_STRINGDATA_19 "1 PLAYER GAME(Title screen)"
#define STRING_STRINGDATA_20 "2 PLAYER GAME(Title screen)"

#define STRING_TESTPLAYSETTING_MARIO      "Regular Mario"
#define STRING_TESTPLAYSETTING_SUPERMARIO "Super Mario"
#define STRING_TESTPLAYSETTING_FIREMARIO  "Fiery Mario"
#define STRING_TESTPLAYSETTING_NONE       "Default" //""
#define STRING_TESTPLAYSETTING_POS        "Position"//"ʒu"
#define STRING_TESTPLAYSETTING_DOT        "Pixel"//"ޯ"

#define STRING_EMULATOROPTION_JOYSTICK   "Pad"//"ޮè"

#define STRING_KEYCONFIG_EMU_A              "A"
#define STRING_KEYCONFIG_EMU_B              "B"
#define STRING_KEYCONFIG_EMU_SELECT         "Select"
#define STRING_KEYCONFIG_EMU_START          "Start"
#define STRING_KEYCONFIG_EMU_UP             "Up"
#define STRING_KEYCONFIG_EMU_DOWN           "Down"
#define STRING_KEYCONFIG_EMU_LEFT           "Left"
#define STRING_KEYCONFIG_EMU_RIGHT          "Right"
#define STRING_KEYCONFIG_EDIT_ADD1          "Object value +1"
#define STRING_KEYCONFIG_EDIT_DEC1          "Object value -1"
#define STRING_KEYCONFIG_EDIT_ADD16         "Object value +16"
#define STRING_KEYCONFIG_EDIT_DEC16         "Object value -16"
#define STRING_KEYCONFIG_EDIT_UP            "Object position to up"
#define STRING_KEYCONFIG_EDIT_DOWN          "Object position to down"
#define STRING_KEYCONFIG_EDIT_LEFT          "Object position to left"
#define STRING_KEYCONFIG_EDIT_RIGHT         "Object position to right"
#define STRING_KEYCONFIG_EDIT_NEXTPAGE      "Next page"
#define STRING_KEYCONFIG_EDIT_PREVPAGE      "Previous page"
#define STRING_KEYCONFIG_EDIT_NEXTOBJ       "Next object"
#define STRING_KEYCONFIG_EDIT_PREVOBJ       "Previous object"
#define STRING_KEYCONFIG_EDIT_SAVEFILE      "File:Save"
#define STRING_KEYCONFIG_EDIT_UNDO          "Edit:Undo"
#define STRING_KEYCONFIG_EDIT_ROOM          "Edit:Choose Room"
#define STRING_KEYCONFIG_EDIT_BADGUYS       "Edit:Badguys Mode"
#define STRING_KEYCONFIG_EDIT_MAP           "Edit:Map Mode"
#define STRING_KEYCONFIG_EDIT_TESTPLAY      "Emulator:Title Screen"
#define STRING_KEYCONFIG_EDIT_PAGETESTPLAY  "Emulator:Current Page"
#define STRING_KEYCONFIG_EDIT_PAGETESTPLAY2 "Emulator:Halfway Point"
#define STRING_KEYCONFIG_EDIT_STOP          "Emulator:End"
#define STRING_KEYCONFIG_EDIT_SAVEEMU       "Emulator:Save"
#define STRING_KEYCONFIG_EDIT_LOADEMU       "Emulator:Load"
#define STRING_KEYCONFIG_EDIT_EMUSETTING    "Emulator:Test Configuration"
#define STRING_KEYCONFIG_EDIT_NEXTWIN       "Window:Next"
#define STRING_KEYCONFIG_EDIT_PREVWIN       "Window:Previous"
#define STRING_KEYCONFIG_KEYACCEL           "Keyboard accelerator"
#define STRING_KEYCONFIG_EMULATOR           "Emulator"
#define STRING_KEYCONFIG_OVERLAPPED         "It is overlapped at %s - \"%s\"."
#define STRING_KEYCONFIG_INITIALIZE         "Load preset-key?"
#define STRING_KEYCONFIG_NOTIFY             "It is enabled at next start."

#define STRING_KEYCONFIG_PRESET_DESKTOP     "Desktop PC(Ten key)"
#define STRING_KEYCONFIG_PRESET_NOTE        "Note PC"

#define STRING_KEYCONFIG_WHEEL_NONE         "None"//"Ȃ"
#define STRING_KEYCONFIG_WHEEL_SHIFT        "+Shift"//"+"
#define STRING_KEYCONFIG_WHEEL_CTRL         "+Ctrl"//"+۰"
#define STRING_KEYCONFIG_WHEEL_SHIFTCTRL    "+Shift+Ctrl"//"++۰"
#define STRING_KEYCONFIG_WHEEL_TYPE1        "Change object value by 1"//"ނ𑝌1"
#define STRING_KEYCONFIG_WHEEL_TYPE16       "Change object value by 16"//"ނ𑝌16"
#define STRING_KEYCONFIG_WHEEL_PAGE         "Select object on next page"//"߰ނƂ̈ړ"
#define STRING_KEYCONFIG_WHEEL_OBJ          "Select object"//"޼ުĂƂ̈ړ"

#define STRING_KEYCONFIG_BUTTONX            "Button%d"//"%d"


#define STRING_OBJLIST_LENNAME   "Length:%d, %s"
#define STRING_OBJLIST_UNKNOWN   "Unknown object"
#define STRING_OBJLIST_CRASH     "*Freezes"
#define STRING_OBJLIST_BACK      "Background:%s"
#define STRING_OBJLIST_VIEWBLOCK "Scene:%s Block:%s"
#define STRING_OBJLIST_ROPE      "Lift's vertical rope"
#define STRING_OBJLIST_LENCASTLE "Castle, Length:%d"
#define STRING_OBJLIST_STEP      "Staircase, Length:%d, Height:%d"
#define STRING_OBJLIST_STEP98    "Staircase, Length:9 Height:8"
#define STRING_OBJLIST_STEP98_2  "*Staircase, Length:9, Height:8"
#define STRING_OBJLIST_NONE      "*Nothing"

#define STRING_OBJLIST_ROOM        "Room change[%.2xH(%s), w=%d, p=%d]"
#define STRING_OBJLIST_PAGECOMMAND "Page skip:%.2d"
#define STRING_OBJLIST_HARD        " (Only after 5-3)"

#define STRING_AREASORT_TITLE "Choose Room"

#define STRING_SEA         "Sea"
#define STRING_SKY         "Ground"
#define STRING_UNDERGROUND "Underground"
#define STRING_CASTLE      "Castle"

#define STRING_OBJLIST_COLUMN_BIN  "Hex"
#define STRING_OBJLIST_COLUMN_PAGE "Page"
#define STRING_OBJLIST_COLUMN_POS  "Position"
#define STRING_OBJLIST_COLUMN_TYPE "Type"

#define STRING_OBJDATA_MAP_B_01 "?Block(Mushroom)"
#define STRING_OBJDATA_MAP_B_02 "?Block(Coin)"
#define STRING_OBJDATA_MAP_B_03 "Hidden block(Coin)"
#define STRING_OBJDATA_MAP_B_04 "Hidden block(1UP mushroom)"
#define STRING_OBJDATA_MAP_B_05 "Brick(Mushroom)"
#define STRING_OBJDATA_MAP_B_06 "Brick(Vine)"
#define STRING_OBJDATA_MAP_B_07 "Brick(Star)"
#define STRING_OBJDATA_MAP_B_08 "Brick(10 coins)"
#define STRING_OBJDATA_MAP_B_09 "Brick(1UP mushroom)"
#define STRING_OBJDATA_MAP_B_10 "Sideways pipe"
#define STRING_OBJDATA_MAP_B_11 "Used block"
#define STRING_OBJDATA_MAP_B_12 "Jumping board"
#define STRING_OBJDATA_MAP_B_13 "Reverse L pipe"
#define STRING_OBJDATA_MAP_B_14 "Flagpole"
#define STRING_OBJDATA_MAP_B_15 "*Nothing"
#define STRING_OBJDATA_MAP_B_16 "*Nothing"
#define STRING_OBJDATA_MAP_B_17 "Island(Cannon)"
#define STRING_OBJDATA_MAP_B_18 "Horizontal bricks(corals)"
#define STRING_OBJDATA_MAP_B_19 "Horizontal blocks"
#define STRING_OBJDATA_MAP_B_20 "Horizontal coins"
#define STRING_OBJDATA_MAP_B_21 "Vertical bricks(corals)"
#define STRING_OBJDATA_MAP_B_22 "Vertical blocks"
#define STRING_OBJDATA_MAP_B_23 "Pipe(Player can't enter.)"
#define STRING_OBJDATA_MAP_B_24 "Pipe(Player can enter.)"

#define STRING_OBJDATA_HELP_B12 ""//"׸̂PB׸ްŕ\ȂȂƁAص܂ďoȂȂ̂ŒӁB"
#define STRING_OBJDATA_HELP_B13 ""//"9ŒBłォłB(ʒu{2)2ו́AɎw肳ꂽQB"
#define STRING_OBJDATA_HELP_B14 ""//"₽ƎgpȂƁB1ٰт2ȏgpƖ\₷Ȃ̂ŒӁB"
#define STRING_OBJDATA_HELP_B23 ""//"1ɂĂK2ɂȂB"

#define STRING_OBJDATA_MAP_C_01 "Hole"
#define STRING_OBJDATA_MAP_C_02 "Balance's horizontal rope"
#define STRING_OBJDATA_MAP_C_03 "Bridge(V=7)"
#define STRING_OBJDATA_MAP_C_04 "Bridge(V=8)"
#define STRING_OBJDATA_MAP_C_05 "Bridge(V=10)"
#define STRING_OBJDATA_MAP_C_06 "Hole filled with water"
#define STRING_OBJDATA_MAP_C_07 "Horizontal ?Blocks(Coin, V=3)"
#define STRING_OBJDATA_MAP_C_08 "Horizontal ?Blocks(Coin, V=7)"

#define STRING_OBJDATA_HELP_C01 ""//"cʒu812̐w肵ׂĂϯ߷ׂB"
#define STRING_OBJDATA_HELP_C02 ""//"cʒu0Œ"
#define STRING_OBJDATA_HELP_C06 ""//"cʒu1012̐w肵ׂĂϯ߷ׂB"

#define STRING_OBJDATA_MAP_D_01 "Page skip"
#define STRING_OBJDATA_MAP_D_02 "Reverse L pipe"
#define STRING_OBJDATA_MAP_D_03 "Flagpole"
#define STRING_OBJDATA_MAP_D_04 "Axe"
#define STRING_OBJDATA_MAP_D_05 "Rope"
#define STRING_OBJDATA_MAP_D_06 "Bridge"
#define STRING_OBJDATA_MAP_D_07 "Scroll stop(warp zone)"
#define STRING_OBJDATA_MAP_D_08 "Scroll stop"
#define STRING_OBJDATA_MAP_D_10 "Cheep-cheep(red, fly)"
#define STRING_OBJDATA_MAP_D_11 "Bullet Bill(Cheep-cheep) continuation"
#define STRING_OBJDATA_MAP_D_12 "Stop continuation"
#define STRING_OBJDATA_MAP_D_13 "Loop command"
#define STRING_OBJDATA_MAP_D_14 "?"
#define STRING_OBJDATA_MAP_D_15 "*Freeze"

#define STRING_OBJDATA_HELP_D01 ""
#define STRING_OBJDATA_HELP_D03 ""//"₽ƎgpȂB1ٰт2ȏgpƖ\₷Ȃ̂ŒӁB"
#define STRING_OBJDATA_HELP_D04 ""//"cʒu6Œ"
#define STRING_OBJDATA_HELP_D05 ""//"cʒu7Œ"
#define STRING_OBJDATA_HELP_D06 ""//"cʒu8A13Œ"
#define STRING_OBJDATA_HELP_D12 ""//"AoׂoA\h߂߰قoOɎwB"
#define STRING_OBJDATA_HELP_D13 ""//"߰ޑނƾĂٰ߂`B"

#define STRING_OBJDATA_MAP_E_01 "Basic brick & scenery"
#define STRING_OBJDATA_MAP_E_02 "Change background"

#define STRING_OBJDATA_MAP_F_01 "Rope of lift"
#define STRING_OBJDATA_MAP_F_02 "Vertical rope of balance lift"
#define STRING_OBJDATA_MAP_F_03 "Castle"
#define STRING_OBJDATA_MAP_F_04 "Staircase(length:n, height:n)"
#define STRING_OBJDATA_MAP_F_05 "Staircase(length:9, height:8)"
#define STRING_OBJDATA_MAP_F_06 "Long reverse L pipe"
#define STRING_OBJDATA_MAP_F_07 "Vertical balls"
#define STRING_OBJDATA_MAP_F_08 "Nothing"

#define STRING_OBJDATA_HELP_F01 ""//"cʒu0A13ŒBw艡ʒuɂāAw肵ׂĂϯ߷ׂB"
#define STRING_OBJDATA_HELP_F02 ""//"cʒu1ŒBw艡ʒuɂāAw肵ׂĂϯ߷ׂB"
#define STRING_OBJDATA_HELP_F03 ""//"₽ƎgpȂƁBgpƖ\₷ȂB"
#define STRING_OBJDATA_HELP_F05 ""//"0`3 ȂB\n4`6 ׂ̨B7 ׂ̨B(ʒu+16)̈ʒuɏcʒu7̉󂹂Ȃۯ1B"
#define STRING_OBJDATA_HELP_F07 ""//"̂悤ɂ܂ď㉺ړ\Bcʒu2Œ"

#define STRING_OBJDATA_BB_01 "Brick:None"
#define STRING_OBJDATA_BB_02 "Brick:Surface"
#define STRING_OBJDATA_BB_03 "Brick:Surface&ceiling"
#define STRING_OBJDATA_BB_04 "Brick:Surface&ceiling(3)"
#define STRING_OBJDATA_BB_05 "Brick:Surface&ceiling(4)"
#define STRING_OBJDATA_BB_06 "Brick:Surface&ceiling(8)"
#define STRING_OBJDATA_BB_07 "Brick:Surface(4)&ceiling"
#define STRING_OBJDATA_BB_08 "Brick:Surface(4)&ceiling(3)"
#define STRING_OBJDATA_BB_09 "Brick:Surface(4)&ceiling(4)"
#define STRING_OBJDATA_BB_10 "Brick:Surface(5)&ceiling"
#define STRING_OBJDATA_BB_11 "Brick:Ceiling"
#define STRING_OBJDATA_BB_12 "Brick:Surface(5)&ceiling(4)"
#define STRING_OBJDATA_BB_13 "Brick:Surface(8)&ceiling"
#define STRING_OBJDATA_BB_14 "Brick:Surface&ceiling&middle(5)"
#define STRING_OBJDATA_BB_15 "Brick:Surface&ceiling&middle(4)"
#define STRING_OBJDATA_BB_16 "Brick:All"

#define STRING_OBJDATA_T_01 "Not set"
#define STRING_OBJDATA_T_02 "400"
#define STRING_OBJDATA_T_03 "300"
#define STRING_OBJDATA_T_04 "200"

#define STRING_OBJDATA_P_01 "V=-1, H=1.5"
#define STRING_OBJDATA_P_02 "Start of area:X, from another room; V=-1, H=1.5"
#define STRING_OBJDATA_P_03 "V=10, H=1.5"
#define STRING_OBJDATA_P_04 "V=4, H=1.5"
#define STRING_OBJDATA_P_07 "V=10, H=1.5(walking)"

#define STRING_OBJDATA_BC_01 "Nothing"
#define STRING_OBJDATA_BC_02 "In water"
#define STRING_OBJDATA_BC_03 "Wall"
#define STRING_OBJDATA_BC_04 "Over water"
#define STRING_OBJDATA_BC_05 "Night"
#define STRING_OBJDATA_BC_06 "Snow"
#define STRING_OBJDATA_BC_07 "Night and snow"
#define STRING_OBJDATA_BC_08 "Castle"

#define STRING_OBJDATA_MT_01 "Green and tree"
#define STRING_OBJDATA_MT_02 "Orange and mushroom"
#define STRING_OBJDATA_MT_03 "Guns"
#define STRING_OBJDATA_MT_04 "Clouds"

#define STRING_OBJDATA_V_01 "Nothing"
#define STRING_OBJDATA_V_02 "Clouds"
#define STRING_OBJDATA_V_03 "Mountain"
#define STRING_OBJDATA_V_04 "Fence"


#define STRING_OBJDATA_BADGUYS_01 "Koopa Troopa(green)"
#define STRING_OBJDATA_BADGUYS_02 "Koopa Troopa(red)"
#define STRING_OBJDATA_BADGUYS_03 "Buzzy Beetle"
#define STRING_OBJDATA_BADGUYS_04 "Koopa Troopa(red, patrol)"
#define STRING_OBJDATA_BADGUYS_05 "Koopa Troopa(green, stopped)"
#define STRING_OBJDATA_BADGUYS_06 "The Hammer Brothers"
#define STRING_OBJDATA_BADGUYS_07 "Little Goomba"
#define STRING_OBJDATA_BADGUYS_08 "Bloober"
#define STRING_OBJDATA_BADGUYS_09 "Bullet Bill"
#define STRING_OBJDATA_BADGUYS_10 "Koopa Paratroopa(green, stopped)"
#define STRING_OBJDATA_BADGUYS_11 "Cheep-cheep(green)"
#define STRING_OBJDATA_BADGUYS_12 "Cheep-cheep(red)"
#define STRING_OBJDATA_BADGUYS_13 "Podoboo"
#define STRING_OBJDATA_BADGUYS_14 "Pirana plants"
#define STRING_OBJDATA_BADGUYS_15 "Koopa Paratroopa(green, leaping)"
#define STRING_OBJDATA_BADGUYS_16 "Koopa Paratroopa(red, up&down)"
#define STRING_OBJDATA_BADGUYS_17 "Koopa Paratroopa(green, right&left)"
#define STRING_OBJDATA_BADGUYS_18 "Lakitu"
#define STRING_OBJDATA_BADGUYS_19 "Spiny"
#define STRING_OBJDATA_BADGUYS_20 "*Unknown"
#define STRING_OBJDATA_BADGUYS_21 "Cheep-cheep(fly)"
#define STRING_OBJDATA_BADGUYS_22 "Bowser's fire"
#define STRING_OBJDATA_BADGUYS_23 "*Crash"
#define STRING_OBJDATA_BADGUYS_24 "Bullet Bill(Cheep-cheep) continuation"
#define STRING_OBJDATA_BADGUYS_25 "*None"
#define STRING_OBJDATA_BADGUYS_28 "Fire Bar(right)"
#define STRING_OBJDATA_BADGUYS_29 "Fire Bar(right, fast)"
#define STRING_OBJDATA_BADGUYS_30 "Fire Bar(left)"
#define STRING_OBJDATA_BADGUYS_31 "Fire Bar(left, fast)"
#define STRING_OBJDATA_BADGUYS_32 "Long Fire Bar(right)"
#define STRING_OBJDATA_BADGUYS_33 "Fire Bar"
#define STRING_OBJDATA_BADGUYS_37 "Lift(balance)"
#define STRING_OBJDATA_BADGUYS_38 "Lift(up&down)"
#define STRING_OBJDATA_BADGUYS_39 "Lift(up)"
#define STRING_OBJDATA_BADGUYS_40 "Lift(down)"
#define STRING_OBJDATA_BADGUYS_41 "Lift(right&left)"
#define STRING_OBJDATA_BADGUYS_42 "Lift(fall)"
#define STRING_OBJDATA_BADGUYS_43 "Lift(surfing)"
#define STRING_OBJDATA_BADGUYS_44 "Short lift(up)"
#define STRING_OBJDATA_BADGUYS_45 "Short lift(down)"
#define STRING_OBJDATA_BADGUYS_46 "Bowser, King of the Koopa"
#define STRING_OBJDATA_BADGUYS_47 "*Unknown"
#define STRING_OBJDATA_BADGUYS_48 "*Unknown"
#define STRING_OBJDATA_BADGUYS_51 "Jumping board(fake)"
#define STRING_OBJDATA_BADGUYS_53 "Warp Zone"
#define STRING_OBJDATA_BADGUYS_54 "Mushroom retainers"
#define STRING_OBJDATA_BADGUYS_56 "2 Little Goomba(V=10)"
#define STRING_OBJDATA_BADGUYS_57 "3 Little Goomba(V=10)"
#define STRING_OBJDATA_BADGUYS_58 "2 Little Goomba(V=6)"
#define STRING_OBJDATA_BADGUYS_59 "3 Little Goomba(V=6)"
#define STRING_OBJDATA_BADGUYS_60 "2 Koopa Troopa(green, V=10)"
#define STRING_OBJDATA_BADGUYS_61 "3 Koopa Troopa(green, V=10)"
#define STRING_OBJDATA_BADGUYS_62 "2 Koopa Troopa(green, V=6)"
#define STRING_OBJDATA_BADGUYS_63 "3 Koopa Troopa(green, V=6)"

// delreg.exe
#define STRING_DELREG_TITLE    "Deleting registry entries of SMB Utility"//_CAÕ^Cg "SMB Utility ڼ޽؂̍폜"
#define STRING_DELREG_CONFIRM  "You are about to delete registry keys that were used in SMB Utility. Are you sure?"//"SMB UtilityŎgpڼ޽؂̷폜܂H"
#define STRING_DELREG_COMPLETE "Deleted registry keys that were used in SMB Utility."//"SMB UtilityŎgpڼ޽؂̷폜܂B"
#define STRING_DELREG_ERROR_01 "Registry keys that were used in SMB Utility don't exist."//"SMB Utilityڼ޽؂̷́A݂܂B"

#endif
